diff --git a/contrib/dlmalloc/dlmalloc_test.c b/contrib/dlmalloc/dlmalloc_test.c
new file mode 100644
index 000000000000..a66d0971d5ef
--- /dev/null
+++ b/contrib/dlmalloc/dlmalloc_test.c
@@ -0,0 +1,186 @@
+#include <stdarg.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <cheri/cheric.h>
+#include "dlmalloc_nonreuse.h"
+
+#ifndef nitems
+#define nitems(x)	(sizeof((x)) / sizeof((x)[0]))
+#endif
+
+const size_t sizes[] = {
+	1,
+	2,
+	3, 4, 5,
+	7, 8, 9,
+	15, 16, 17,
+	31, 32, 33,
+	63, 64, 65,
+	127, 128, 129,
+	255, 256, 257,
+	511, 512, 513,
+	1023, 1024, 1025,
+	2047, 2048, 2049,
+	4095, 4096, 4097,
+	1024 * 1024 - 1, 1024 * 1024, 1024 * 1024 + 1
+};
+
+#define bad_ptr(ptr, fmt, ...)	\
+    _bad_ptr((ptr), __FILE__, __LINE__, (fmt), ##__VA_ARGS__)
+
+void
+_bad_ptr(void *ptr, const char *file, int line, const char *fmt, ...)
+{
+	va_list ap;
+
+	printf("%s:%d: bad pointer %#p\n", file, line, ptr);
+	va_start(ap, fmt);
+	vprintf(fmt, ap);
+	va_end(ap);
+	if (fmt[strlen(fmt) - 1] != '\n')
+		printf("\n");
+	abort();
+}
+
+static void *
+malloc_checked(size_t bytes)
+{
+	void *ptr;
+
+	ptr = dlmalloc(bytes);
+	if (bytes == 0 && ptr == NULL)
+		return (ptr);
+	if (!cheri_gettag(ptr))
+		bad_ptr(ptr, "missing tag");
+	if (cheri_getlen(ptr) < bytes)
+		bad_ptr(ptr, "length is less than %zu", bytes);
+#ifdef CHERI_SET_BOUNDS
+	if (cheri_getoffset(ptr) != 0)
+		bad_ptr(ptr, "pointer has non-zero offset");
+#endif
+	return (ptr);
+}
+
+static void *
+calloc_checked(size_t number, size_t size)
+{
+	void *ptr;
+
+	ptr = dlcalloc(number, size);
+	if (number * size == 0 && ptr == NULL)
+		return (ptr);
+	if (!cheri_gettag(ptr))
+		bad_ptr(ptr, "missing tag");
+	if (cheri_getlen(ptr) < number * size)
+		bad_ptr(ptr, "length is less than %zu", number * size);
+#ifdef CHERI_SET_BOUNDS
+	if (cheri_getoffset(ptr) != 0)
+		bad_ptr(ptr, "pointer has non-zero offset");
+#endif
+	return (ptr);
+}
+
+static void *
+realloc_checked(void *optr, size_t bytes)
+{
+	void *ptr;
+
+	ptr = dlrealloc(optr, bytes);
+	if (bytes == 0 && ptr == NULL)
+		return (ptr);
+	if (!cheri_gettag(ptr))
+		bad_ptr(ptr, "missing tag");
+	if (cheri_getlen(ptr) < bytes)
+		bad_ptr(ptr, "length is less than %zu", bytes);
+#ifdef CHERI_SET_BOUNDS
+	if (cheri_getoffset(ptr) != 0)
+		bad_ptr(ptr, "pointer has non-zero offset");
+#endif
+	return (ptr);
+}
+
+int
+main(int argc, char **argv)
+{
+	void *ptrs[nitems(sizes)];
+	int i;
+
+	/* ----- malloc tests ----- */
+	for (i = 0; i < nitems(sizes); i++)
+		ptrs[i] = malloc_checked(sizes[i]);
+#ifdef CAPREVOKE
+	dlmalloc_revoke();
+	for (i = 0; i < nitems(sizes); i++)
+		if (cheri_getperm(ptrs[i]) == 0)
+			bad_ptr(ptrs[i],
+			    "ptrs[%d] is revoked before being freed", i);
+#endif
+	/* Free even pointers */
+	for (i = 0; i < nitems(sizes); i += 2)
+		dlfree(ptrs[i]);
+#ifdef CAPREVOKE
+	dlmalloc_revoke();
+	/*
+	 * Check that even pointers were revoked and odd ones were not,
+	 * freeing odd ones.
+	 */
+	for (i = 0; i < nitems(sizes); i += 2)
+		if (cheri_getperm(ptrs[i]) != 0)
+			bad_ptr(ptrs[i], "ptrs[%d] was not revoked", i);
+	for (i = 1; i < nitems(sizes); i += 2)
+		if (cheri_getperm(ptrs[i]) == 0)
+			bad_ptr(ptrs[i],
+			    "ptrs[%d] is revoked before being freed", i);
+	dlmalloc_revoke();
+#endif
+	/* Free odd pointers */
+	for (i = 1; i < nitems(sizes); i += 2)
+		dlfree(ptrs[i]);
+
+	/* ----- calloc tests ----- */
+	for (i = 0; i < nitems(sizes); i++)
+		ptrs[i] = calloc_checked(1, sizes[i]);
+#ifdef CAPREVOKE
+	dlmalloc_revoke();
+	for (i = 0; i < nitems(sizes); i++)
+		if (cheri_getperm(ptrs[i]) == 0)
+			bad_ptr(ptrs[i],
+			    "ptrs[%d] is revoked before being freed", i);
+#endif
+	/* Free even pointers */
+	for (i = 0; i < nitems(sizes); i += 2)
+		dlfree(ptrs[i]);
+#ifdef CAPREVOKE
+	dlmalloc_revoke();
+	/*
+	 * Check that even pointers were revoked and odd ones were not,
+	 * freeing odd ones.
+	 */
+	for (i = 0; i < nitems(sizes); i += 2)
+		if (cheri_getperm(ptrs[i]) != 0)
+			bad_ptr(ptrs[i], "ptrs[%d] was not revoked", i);
+	for (i = 1; i < nitems(sizes); i += 2)
+		if (cheri_getperm(ptrs[i]) == 0)
+			bad_ptr(ptrs[i],
+			    "ptrs[%d] is revoked before being freed", i);
+	dlmalloc_revoke();
+#endif
+	/* Free odd pointers */
+	for (i = 1; i < nitems(sizes); i += 2)
+		dlfree(ptrs[i]);
+
+	/* ----- realloc tests ----- */
+	ptrs[0] = realloc_checked(NULL, sizes[0]);
+	for (i = 1; i < nitems(sizes); i++)
+		ptrs[i] = realloc_checked(ptrs[i - 1], sizes[i]);
+	dlfree(ptrs[nitems(sizes) - 1]);
+#ifdef CAPREVOKE
+	dlmalloc_revoke();
+	for (i = 0; i < nitems(sizes); i++)
+		if (cheri_getperm(ptrs[i]) != 0)
+			bad_ptr(ptrs[i], "ptrs[%d] was not revoked", i);
+#endif
+
+	return (0);
+}
diff --git a/contrib/subrepo-cheri-libunwind/src/DwarfParser.hpp b/contrib/subrepo-cheri-libunwind/src/DwarfParser.hpp
index af0ab293f02c..af42c368cf6d 100644
--- a/contrib/subrepo-cheri-libunwind/src/DwarfParser.hpp
+++ b/contrib/subrepo-cheri-libunwind/src/DwarfParser.hpp
@@ -153,7 +153,6 @@ const char *CFI_Parser<A>::decodeFDE(A &addressSpace, pc_t pc, pint_t fdeStart,
       addressSpace.getEncodedP(p, nextCFI, cieInfo->pointerEncoding);
 #ifdef __CHERI_PURE_CAPABILITY__
   // This should not be a valid pointer:
-  assert(!__builtin_cheri_tag_get((void*)_pcStart));
   addr_t pcStart = __builtin_cheri_address_get((void*)_pcStart);
 #else
   addr_t pcStart = (addr_t)_pcStart;
@@ -161,7 +160,6 @@ const char *CFI_Parser<A>::decodeFDE(A &addressSpace, pc_t pc, pint_t fdeStart,
   pint_t _pcRange = addressSpace.getEncodedP(
       p, nextCFI, cieInfo->pointerEncoding & 0x0F);
 #ifdef __CHERI_PURE_CAPABILITY__
-  assert(!__builtin_cheri_tag_get((void*)_pcRange));
   addr_t pcRange = __builtin_cheri_address_get((void*)_pcRange);
 #else
   addr_t pcRange = (addr_t)_pcRange;
diff --git a/lib/Makefile b/lib/Makefile
index 42bd4b7a17b5..9fcb3e2ac599 100644
--- a/lib/Makefile
+++ b/lib/Makefile
@@ -151,6 +151,7 @@ SUBDIR.${MK_BSNMP}+=	libbsnmp
 
 SUBDIR.${MK_LIBCHERI}+=	libhelloworld
 SUBDIR.${MK_CHERI}+=	libsyscalls
+SUBDIR.${MK_CHERI}+=	libcheri_caprevoke
 
 .if ${MK_LIBCHERI} == "yes" && ${MACHINE_ARCH} != "mips"
 _libc_cheri=	libc_cheri
@@ -271,4 +272,5 @@ SUBDIR.${MK_LIBCHERI}+=	libcheri_syscalls
 SUBDIR.${MK_LIBCHERI}+=	libcheri_support
 .endif
 
+
 .include <bsd.subdir.mk>
diff --git a/lib/libc/Makefile b/lib/libc/Makefile
index e6269884e055..22f569aa8e47 100644
--- a/lib/libc/Makefile
+++ b/lib/libc/Makefile
@@ -108,7 +108,11 @@ NOASM=
 .include "${LIBC_SRCTOP}/resolv/Makefile.inc"
 .include "${LIBC_SRCTOP}/stdio/Makefile.inc"
 .include "${LIBC_SRCTOP}/stdlib/Makefile.inc"
+.if ${MK_DLMALLOC} == "no" || !defined(LIBCHERI)
 .include "${LIBC_SRCTOP}/stdlib/jemalloc/Makefile.inc"
+.else
+.include "${LIBC_SRCTOP}/stdlib/dlmalloc/Makefile.inc"
+.endif
 .include "${LIBC_SRCTOP}/stdtime/Makefile.inc"
 .include "${LIBC_SRCTOP}/string/Makefile.inc"
 .if !defined(NO_SYSCALLS)
diff --git a/lib/libc/gen/Makefile.inc b/lib/libc/gen/Makefile.inc
index db45832e010d..d609c043412c 100644
--- a/lib/libc/gen/Makefile.inc
+++ b/lib/libc/gen/Makefile.inc
@@ -176,6 +176,12 @@ SRCS+=	devname-compat11.c \
 	unvis-compat.c
 .endif
 
+.if ${MACHINE_ARCH:Mmips*c*} && ${MK_CHERI_CAPREVOKE}
+CFLAGS.tls_malloc.c+=	-DCAPREVOKE
+.PATH:	${SRCTOP}/lib/libcheri_caprevoke
+SRCS+=	libcheri_caprevoke.c
+.endif
+
 CFLAGS.arc4random.c= -I${SRCTOP}/sys -I${SRCTOP}/sys/crypto/chacha20
 
 .PATH: ${SRCTOP}/contrib/libc-pwcache
diff --git a/lib/libc/gen/tls_malloc.c b/lib/libc/gen/tls_malloc.c
index 200c7bb3e996..5a9945bed0a4 100644
--- a/lib/libc/gen/tls_malloc.c
+++ b/lib/libc/gen/tls_malloc.c
@@ -60,6 +60,11 @@
 
 #ifdef __CHERI_PURE_CAPABILITY__
 #include <cheri/cheric.h>
+#ifdef CAPREVOKE
+#include <sys/caprevoke.h>
+#include <sys/stdatomic.h>
+#include <cheri/caprevoke.h>
+#endif
 #endif
 
 #include <assert.h>
@@ -92,7 +97,9 @@ static void *__tls_malloc_aligned(size_t size, size_t align);
  * byte is set to MAGIC, and the second byte is the size index.
  */
 union	overhead {
+	struct {
 	union	overhead *ov_next;	/* when free */
+	};
 	struct {
 		u_char	ovu_magic;	/* magic number */
 		u_char	ovu_index;	/* bucket # */
@@ -101,6 +108,19 @@ union	overhead {
 #define	ov_index	ovu.ovu_index
 };
 
+struct pagepool_header {
+	size_t			 ph_size;
+#ifdef __CHERI_PURE_CAPABILITY__
+	size_t			 ph_pad1;
+	/* XXXBD: more padding on 256-bit... */
+#endif
+	struct pagepool_header	*ph_next;
+#ifdef CAPREVOKE
+	void			*ph_shadow;
+	void			*ph_pad2; /* Align strongly */
+#endif
+};
+
 #define	MALLOC_ALIGNMENT	sizeof(union overhead)
 
 #define	MAGIC		0xef		/* magic # on accounting info */
@@ -110,44 +130,44 @@ union	overhead {
  * (FIRST_BUCKET_SIZE << i).  The overhead information precedes the
  * data area returned to the user.
  */
-#define	FIRST_BUCKET_SIZE	32
+#define	FIRST_BUCKET_SHIFT	5
+#define	FIRST_BUCKET_SIZE	(1 << FIRST_BUCKET_SHIFT)
 #define	NBUCKETS 30
 static	union overhead *nextf[NBUCKETS];
 
+#ifdef CAPREVOKE
+/*
+ * In the CAPREVOKE case, we encode the bucket in the next pointer's low
+ * bit in the quarantine pool.  The static assert ensures that remains
+ * possible.
+ */
+_Static_assert(NBUCKETS < FIRST_BUCKET_SIZE,
+    "Not enough alignment to encode bucket in pointer bits");
+#define	MAX_QUARANTINE	(1024 * 1024)
+static union overhead *quarantine_bufs[NBUCKETS];
+static size_t quarantine_size;
+#endif
+
 static const size_t pagesz = PAGE_SIZE;			/* page size */
 
 #define	NPOOLPAGES	(32*1024/pagesz)
 
 static caddr_t	pagepool_start, pagepool_end;
-static size_t	n_pagepools, max_pagepools;
-static char	**pagepool_list;
+static struct pagepool_header	*curpp;
 
-static void
-__morepools(void)
-{
-	size_t osize, nsize;
-	char **new_pagepool_list;
-
-	osize = max_pagepools * sizeof(char *);
-	if (max_pagepools == 0)
-		max_pagepools = pagesz / (sizeof(char *) * 2);
-	max_pagepools *= 2;
-	nsize = max_pagepools * sizeof(char *);
-	if ((new_pagepool_list = mmap(0, nsize, PROT_READ|PROT_WRITE,
-	    MAP_ANON, -1, 0)) == MAP_FAILED)
-		abort();
-	memcpy(new_pagepool_list, pagepool_list, osize);
-	if (pagepool_list != NULL) {
-		if (munmap(pagepool_list, osize) != 0)
-			abort();
-	}
-	pagepool_list = new_pagepool_list;
-}
+#ifdef CAPREVOKE
+volatile const struct caprevoke_info *cri;
+
+static void paint_shadow(void *mem, size_t size);
+static void clear_shadow(void *mem, size_t size);
+static void do_revoke();
+#endif
 
 static int
 __morepages(int n)
 {
 	size_t	size;
+	struct pagepool_header *newpp;
 
 	n += NPOOLPAGES;	/* round up allocation. */
 	size = n * pagesz;
@@ -155,9 +175,6 @@ __morepages(int n)
 	size = CHERI_REPRESENTABLE_LENGTH(size);
 #endif
 
-	if (n_pagepools >= max_pagepools)
-		__morepools();
-
 	if (pagepool_end - pagepool_start > (ssize_t)pagesz) {
 		caddr_t extra_start = __builtin_align_up(pagepool_start,
 		    pagesz);
@@ -181,12 +198,15 @@ __morepages(int n)
 #endif
 	}
 
-	if ((pagepool_start = mmap(0, size, PROT_READ|PROT_WRITE,
-	    MAP_ANON, -1, 0)) == MAP_FAILED)
+	if ((newpp = mmap(0, size, PROT_READ|PROT_WRITE, MAP_ANON, -1,
+	    0)) == MAP_FAILED)
 		return (0);
 
-	pagepool_end = pagepool_start + size;
-	pagepool_list[n_pagepools++] = pagepool_start;
+	newpp->ph_next = curpp;
+	newpp->ph_size = size;
+	curpp = newpp;
+	pagepool_start = (char *)(newpp + 1);
+	pagepool_end = pagepool_start + (size - sizeof(*newpp));
 
 	return (size / pagesz);
 }
@@ -197,17 +217,23 @@ __rederive_pointer(void *ptr)
 #ifndef __CHERI_PURE_CAPABILITY__
 	return (ptr);
 #else
-	size_t i;
+	struct pagepool_header *pp;
 	vm_offset_t addr;
 
 	addr = cheri_getaddress(ptr);
 	TLS_MALLOC_LOCK;
-	for (i = 0; i < n_pagepools; i++) {
-		char *pool = pagepool_list[i];
+	/*
+	 * It's OK if more pools are added, they can't contain our pointer
+	 * and we never mutate the list except when adding to the front.
+	 */
+	pp = curpp;
+	TLS_MALLOC_UNLOCK;
+	while (pp != NULL) {
+		char *pool = (char *)pp;
 		if (cheri_is_address_inbounds(pool, addr))
 			return (cheri_setaddress(pool, addr));
+		pp = pp->ph_next;
 	}
-	TLS_MALLOC_UNLOCK;
 
 	return (NULL);
 #endif
@@ -224,6 +250,49 @@ bound_ptr(void *mem, size_t nbytes)
 	return (ptr);
 }
 
+#ifdef CAPREVOKE
+static void
+try_revoke(int target_bucket)
+{
+	int bucket;
+	union overhead *op, *next_op;
+
+	/*
+	 * Don't revoke unless there is enough in quarantine and some of
+	 * it would be returned to the bucket we want to refill.
+	 */
+	 if (quarantine_bufs[target_bucket] == NULL ||
+	     quarantine_size < MAX_QUARANTINE)
+	     return;
+
+	for (bucket = 0; bucket < NBUCKETS; bucket++) {
+		for (op = quarantine_bufs[bucket]; op != NULL;
+		    op = op->ov_next)
+			paint_shadow(op, FIRST_BUCKET_SIZE << bucket);
+	}
+	atomic_thread_fence(memory_order_acq_rel);
+
+	do_revoke();
+
+	 for (bucket = 0; bucket < NBUCKETS; bucket++) {
+		for (op = quarantine_bufs[bucket]; op != NULL;
+		    op = op->ov_next)
+			clear_shadow(op, FIRST_BUCKET_SIZE << bucket);
+	}
+	atomic_thread_fence(memory_order_acq_rel);
+
+	for (bucket = 0; bucket < NBUCKETS; bucket++) {
+		op = quarantine_bufs[bucket];
+		while (op != NULL) {
+			next_op = op->ov_next;
+			op->ov_next = nextf[bucket];
+			nextf[bucket] = op;
+		}
+	}
+	quarantine_size = 0;
+}
+#endif
+
 static void *
 __tls_malloc(size_t nbytes)
 {
@@ -251,6 +320,10 @@ __tls_malloc(size_t nbytes)
 	 * request more memory from the system.
 	 */
 	TLS_MALLOC_LOCK;
+#ifdef CAPREVOKE
+	if ((op = nextf[bucket]) == NULL)
+		try_revoke(bucket);
+#endif
 	if ((op = nextf[bucket]) == NULL) {
 		morecore(bucket);
 		if ((op = nextf[bucket]) == NULL)
@@ -398,6 +471,53 @@ nextf_insert(void *mem, size_t size, int xbucket)
 	nextf[bucket] = op;
 }
 
+#ifdef CAPREVOKE
+static void
+paint_shadow(void *mem, size_t size)
+{
+	struct pagepool_header *pp;
+
+	pp = cheri_setoffset(pp, 0);
+	/*
+	 * Defer initializing ph_shadow since odds are good we'll never
+	 * need it.
+	 */
+	if (pp->ph_shadow == NULL)
+		if (caprevoke_shadow(CAPREVOKE_SHADOW_NOVMMAP, pp,
+		    &pp->ph_shadow) != 0)
+			abort();
+	caprev_shadow_nomap_set_raw(pp->ph_shadow, (vaddr_t)mem, size);
+}
+
+static void
+clear_shadow(void *mem, size_t size)
+{
+	struct pagepool_header *pp;
+
+	pp = cheri_setoffset(pp, 0);
+	caprev_shadow_nomap_clear_raw(pp->ph_shadow, (vaddr_t)mem, size);
+}
+
+static void
+do_revoke(void)
+{
+	int error;
+
+	if (cri == NULL) {
+		error = caprevoke_shadow(CAPREVOKE_SHADOW_INFO_STRUCT, NULL,
+		    (void **)&cri);
+		assert(error == 0);
+	}
+
+	caprevoke_epoch start_epoch = cri->epoch_enqueue;
+	while (!caprevoke_epoch_clears(cri->epoch_dequeue, start_epoch)) {
+		struct caprevoke_stats crst;
+		error = caprevoke(CAPREVOKE_LAST_PASS, start_epoch, &crst);
+		assert(error == 0);
+	}
+}
+#endif /* CAPREVOKE */
+
 void
 tls_free(void *cp)
 {
@@ -413,7 +533,13 @@ tls_free(void *cp)
 	bucket = op->ov_index;
 	if (bucket < NBUCKETS)
 		abort();
+#ifdef CAPREVOKE
+	op->ov_next = quarantine_bufs[bucket];
+	quarantine_bufs[bucket] = op;
+	quarantine_size += FIRST_BUCKET_SIZE << bucket;
+#else
 	nextf_insert(op, FIRST_BUCKET_SIZE << bucket, bucket);
+#endif
 	TLS_MALLOC_UNLOCK;
 }
 
diff --git a/lib/libc/stdlib/dlmalloc/Makefile.inc b/lib/libc/stdlib/dlmalloc/Makefile.inc
new file mode 100644
index 000000000000..43e7567f2aac
--- /dev/null
+++ b/lib/libc/stdlib/dlmalloc/Makefile.inc
@@ -0,0 +1,23 @@
+# $FreeBSD$
+
+.PATH: ${LIBC_SRCTOP}/stdlib/dlmalloc
+.PATH: ${SRCTOP}/contrib/dlmalloc
+
+DLMALLOCSRCS:= dlmalloc_nonreuse.c dlmalloc_libc_stubs.c
+
+SYM_MAPS+=${LIBC_SRCTOP}/stdlib/dlmalloc/Symbol.map
+
+CFLAGS+=-I${SRCTOP}/contrib/dlmalloc
+
+.if ${MK_CHERI_CAPREVOKE} == "yes"
+.PATH: ${SRCTOP}/lib/libcheri_caprevoke
+DLMALLOCSRCS+=		libcheri_caprevoke.c
+DLMALLOC_CFLAGS+=	-DCHERI_SET_BOUNDS -DSAFE_FREEBUF
+DLMALLOC_CFLAGS+=	-DCAPREVOKE -DDEFAULT_MAX_FREEBUFBYTES=8388608
+DLMALLOC_CFLAGS+=	-DDCONSOLIDATE_ON_FREE=1
+DLMALLOC_CFLAGS+=	-DZERO_MEMORY=0
+DLMALLOC_CFLAGS+=	-DSUPPORT_UNMAP=1
+.endif
+CFLAGS.dlmalloc_nonreuse.c+=	${DLMALLOC_CFLAGS}
+
+SRCS+=	${DLMALLOCSRCS}
diff --git a/lib/libc/stdlib/dlmalloc/dlmalloc_libc_stubs.c b/lib/libc/stdlib/dlmalloc/dlmalloc_libc_stubs.c
new file mode 100644
index 000000000000..a1489995ff93
--- /dev/null
+++ b/lib/libc/stdlib/dlmalloc/dlmalloc_libc_stubs.c
@@ -0,0 +1,51 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019 SRI interntional
+ *
+ * This software was developed by SRI International and the University of
+ * Cambridge Computer Laboratory (Department of Computer Science and
+ * Technology) under DARPA contract HR0011-18-C-0016 ("ECATS"), as part of the
+ * DARPA SSITH research programme.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+void
+_malloc_thread_cleanup(void)
+{
+}
+
+void
+_malloc_prefork(void)
+{
+}
+
+void
+_malloc_postfork(void)
+{
+}
+
+void
+_malloc_first_thread(void)
+{
+}
diff --git a/lib/libc/tests/stdlib/Makefile b/lib/libc/tests/stdlib/Makefile
index e0386890c9da..01a2fef59bdf 100644
--- a/lib/libc/tests/stdlib/Makefile
+++ b/lib/libc/tests/stdlib/Makefile
@@ -36,7 +36,9 @@ NETBSD_ATF_TESTS_C+=	div_test
 NETBSD_ATF_TESTS_C+=	getenv_test
 NETBSD_ATF_TESTS_C+=	exit_test
 NETBSD_ATF_TESTS_C+=	hsearch_test
+.if ${MK_DLMALLOC} == no || !defined(LIBCHERI)
 NETBSD_ATF_TESTS_C+=	posix_memalign_test
+.endif
 NETBSD_ATF_TESTS_C+=	random_test
 NETBSD_ATF_TESTS_C+=	strtod_test
 NETBSD_ATF_TESTS_C+=	strtol_test
diff --git a/lib/libcheri_caprevoke/Makefile b/lib/libcheri_caprevoke/Makefile
new file mode 100644
index 000000000000..a303993343f0
--- /dev/null
+++ b/lib/libcheri_caprevoke/Makefile
@@ -0,0 +1,17 @@
+SRCS= libcheri_caprevoke.c
+
+INCS= caprevoke.h
+INCSDIR=	${INCLUDEDIR}/cheri
+
+CFLAGS+= -I${.CURDIR}
+CFLAGS+= -I${.CURDIR}/${MACHINE_ARCH}
+
+LIB=cheri_caprevoke
+SHLIB= cheri_caprevoke
+SHLIB_MAJOR= 1
+
+NO_WERROR=
+WANT_CHERI=yes
+
+.include "../Makefile.inc"
+.include <bsd.lib.mk>
diff --git a/lib/libcheri_caprevoke/caprevoke.h b/lib/libcheri_caprevoke/caprevoke.h
new file mode 100644
index 000000000000..6404a270b597
--- /dev/null
+++ b/lib/libcheri_caprevoke/caprevoke.h
@@ -0,0 +1,47 @@
+#ifndef LIBCHERI_CAPREVOKE_H
+#define LIBCHERI_CAPREVOKE_H
+
+#include <stddef.h>
+#include <sys/caprevoke.h>
+
+/*
+ * The per-object interface protects against concurrent mutation and both
+ * intra- and inter-epoch double-frees.
+ */
+int caprev_shadow_nomap_set_len(uint64_t * __capability sb,
+                                vaddr_t ob,
+                                size_t len,
+                                void * __capability user_obj);
+
+void caprev_shadow_nomap_clear_len(uint64_t * __capability sb,
+                                   vaddr_t ob,
+                                   size_t len);
+
+int caprev_shadow_nomap_set(uint64_t * __capability sb,
+                            void * __capability priv_obj,
+                            void * __capability user_obj);
+
+void caprev_shadow_nomap_clear(uint64_t * __capability sb,
+                               void * __capability obj);
+
+/*
+ * For already interlocked allocators where these protections are not
+ * necessary, we also export a "raw" interface, which is especially useful
+ * when objects can coalesce in quarantine prior to being staged for
+ * revocation, as fewer bitmap writes are necessary.
+ */
+
+void caprev_shadow_nomap_set_raw(uint64_t * __capability sb,
+                                 vaddr_t heap_start, vaddr_t heap_end);
+
+void caprev_shadow_nomap_clear_raw(uint64_t * __capability sb,
+                                   vaddr_t heap_start, vaddr_t heap_end);
+
+/* Utility functions for testing */
+void caprev_shadow_nomap_offsets(vaddr_t ob, size_t len,
+                                 ptrdiff_t *fwo, ptrdiff_t *lwo);
+
+void caprev_shadow_nomap_masks(vaddr_t ob, size_t len,
+                               uint64_t *fwm, uint64_t *lwm);
+
+#endif
